'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduxFormMiddleware = undefined;

var _reduxFormDraftjs = require('redux-form-draftjs');

var _submits = require('./submits');

var _submits2 = _interopRequireDefault(_submits);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reduxFormMiddleware = exports.reduxFormMiddleware = function reduxFormMiddleware(store) {
  return function (next) {
    return function (action) {
      // eslint-disable-line
      /* eslint guard-for-in: 0 */
      for (var formId in _submits2.default) {
        var _submits$formId = _submits2.default[formId],
            succeeded = _submits$formId.succeeded,
            failed = _submits$formId.failed,
            resolve = _submits$formId.resolve,
            reject = _submits$formId.reject;

        if (succeeded(action)) {
          delete _submits2.default[formId];
          resolve();
        } else if (failed(action)) {
          var payload = action.payload;

          var value = void 0;
          if (payload) {
            value = payload instanceof _reduxFormDraftjs.SubmissionError ? payload : new _reduxFormDraftjs.SubmissionError(payload);
          }
          delete _submits2.default[formId];
          reject(value);
        }
      }
      return next(action);
    };
  };
};