'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _submits = require('./submits');

var _submits2 = _interopRequireDefault(_submits);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPredicate(strOrFn) {
  if (typeof strOrFn === 'string') {
    return function (action) {
      return action.type === strOrFn;
    };
  }
  return strOrFn;
}

function enhance(id, props) {
  var _props = props,
      _onSubmit = _props.onSubmit,
      succeededAction = _props.succeededAction,
      failedAction = _props.failedAction;


  if (_onSubmit || succeededAction || failedAction) {
    var succeeded = createPredicate(succeededAction);
    var failed = createPredicate(failedAction);

    if (typeof _onSubmit !== 'function') throw new Error('\'' + id + '\' form > onSubmit must be function or string');
    if (typeof succeeded !== 'function') throw new Error('\'' + id + '\' form > succeededAction should be function or string');

    props = (0, _extends3.default)({}, props, {
      onSubmit: function onSubmit() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return new _promise2.default(function (resolve, reject) {
          _submits2.default[id] = { succeeded: succeeded, failed: failed, resolve: resolve, reject: reject };
          _onSubmit.apply(undefined, args);
        });
      }
    });
  }
  return props;
}

exports.default = function (reduxForm) {
  return function (options) {
    return function (Component) {
      var id = options.form;
      /* enhance options when new components wrapper is created */
      var ReduxForm = reduxForm(enhance(id, options))(Component);
      /* but enhance must be done also on component props
         redux form allows define options on both levels */
      return function (props) {
        return _react2.default.createElement(ReduxForm, enhance(id, props));
      };
    };
  };
};